import * as platejs from 'platejs';
import { SlateEditor, SetNodesOptions, PluginConfig } from 'platejs';
import { A as Alignment } from './setAlign-RbSBJApQ.js';
export { s as setAlign } from './setAlign-RbSBJApQ.js';

declare const BaseFontBackgroundColorPlugin: platejs.SlatePlugin<platejs.PluginConfig<"backgroundColor", {}, {}, Record<"backgroundColor", {
    addMark: (value: string) => void;
}>, {}>>;

declare const BaseFontColorPlugin: platejs.SlatePlugin<platejs.PluginConfig<"color", {}, {}, Record<"color", {
    addMark: (value: string) => void;
}>, {}>>;

declare const BaseFontFamilyPlugin: platejs.SlatePlugin<platejs.PluginConfig<"fontFamily", {}, {}, Record<"fontFamily", {
    addMark: (value: string) => void;
}>, {}>>;

declare const BaseFontSizePlugin: platejs.SlatePlugin<platejs.PluginConfig<"fontSize", {}, {}, Record<"fontSize", {
    addMark: (value: string) => void;
}>, {}>>;

declare const BaseFontWeightPlugin: platejs.SlatePlugin<platejs.PluginConfig<"fontWeight", {}, {}, Record<"fontWeight", {
    addMark: (value: string) => void;
}>, {}>>;

/**
 * Enables support for text alignment, useful to align your content to left,
 * right and center it.
 */
declare const BaseLineHeightPlugin: platejs.SlatePlugin<platejs.PluginConfig<"lineHeight", {}, {}, Record<"lineHeight", {
    setNodes: (value: number, setNodesOptions?: platejs.SetNodesOptions | undefined) => void;
}>, {}>>;

declare const setLineHeight: (editor: SlateEditor, value: number, setNodesOptions?: SetNodesOptions) => void;

/** Creates a plugin that adds alignment functionality to the editor. */
declare const BaseTextAlignPlugin: platejs.SlatePlugin<platejs.PluginConfig<"textAlign", {}, {}, Record<"textAlign", {
    setNodes: (value: Alignment, setNodesOptions?: platejs.SetNodesOptions | undefined) => void;
}>, {}>>;

type TextIndentConfig = PluginConfig<'textIndent', {
    offset: number;
    unit: string;
}>;
declare const BaseTextIndentPlugin: platejs.SlatePlugin<TextIndentConfig>;

declare const toUnitLess: (value: string) => string;

export { Alignment, BaseFontBackgroundColorPlugin, BaseFontColorPlugin, BaseFontFamilyPlugin, BaseFontSizePlugin, BaseFontWeightPlugin, BaseLineHeightPlugin, BaseTextAlignPlugin, BaseTextIndentPlugin, type TextIndentConfig, setLineHeight, toUnitLess };
